//Register file
//Kamyar Rafati & Naeem Esfahani

module RegFile_16bit (RAdr1, Out1, RAdr2, Out2, WAdr, WData, RegWrite, CLK);

	input[3:0]		RAdr1, RAdr2, WAdr;
	input[15:0]		WData;
	input			RegWrite, CLK;
	output[15:0]	Out1, Out2;
	reg[15:0]		Out1, Out2;

	reg[15:0]		Reg0, Reg1, Reg2, Reg3, Reg4, Reg5, Reg6, Reg7, Reg8, Reg9, Reg10, 
					Reg11, Reg12, Reg13, Reg14, Reg15 ;

// Write
	always @(posedge CLK)//WAdr or WData or RegWrite or
	begin
		if (RegWrite &&  CLK)
			case (WAdr)
				0: Reg0=WData;
				1: Reg1=WData;
				2: Reg2=WData;
				3: Reg3=WData;
				4: Reg4=WData;
				5: Reg5=WData;
				6: Reg6=WData;
				7: Reg7=WData;
				8: Reg8=WData;
				9: Reg9=WData;
				10: Reg10=WData;
				11: Reg11=WData;
				12: Reg12=WData;
				13: Reg13=WData;
				14: Reg14=WData;
				15: Reg15=WData;
			endcase
		end
		
//Read
	always @(negedge CLK)
	begin
		case(RAdr1)
			0: Out1 = Reg0;
			1: Out1 = Reg1;
			2: Out1 = Reg2;
			3: Out1 = Reg3;
			4: Out1 = Reg4;
			5: Out1 = Reg5;
			6: Out1 = Reg6;
			7: Out1 = Reg7;
			8: Out1 = Reg8;
			9: Out1 = Reg9;
			10: Out1 = Reg10;
			11: Out1 = Reg11;
			12: Out1 = Reg12;
			13: Out1 = Reg13;
			14: Out1 = Reg14;
			15: Out1 = Reg15;
		endcase
		case(RAdr2)
			0: Out2 = Reg0;
			1: Out2 = Reg1;
			2: Out2 = Reg2;
			3: Out2 = Reg3;
			4: Out2 = Reg4;
			5: Out2 = Reg5;
			6: Out2 = Reg6;
			7: Out2 = Reg7;
			8: Out2 = Reg8;
			9: Out2 = Reg9;
			10: Out2 = Reg10;
			11: Out2 = Reg11;
			12: Out2 = Reg12;
			13: Out2 = Reg13;
			14: Out2 = Reg14;
			15: Out2 = Reg15;
		endcase
	end
	initial
	begin
		Reg0=0;
		Reg1=0;
		Reg2=0;
		Reg3=0;
		Reg4=0;
		Reg7=0;
	end
endmodule
