module Cond_Detect(out,OpCode,c,z,n,e);
	output	out;
	reg	out;
	input	[3:0] OpCode;
	input	c,z,n,e;

	always @(OpCode or c or n or z or e)
	case(OpCode)
		0:	out = c;
		1:	out = z;
		2:	out = n;
		3:	out = c|z;
		4:	out = e;
		default: out = 0;	
	endcase
endmodule