module cpu();

	reg clk,reset;

	wire	[15:0]	Op;
	wire		i,IsFull,IsEmpty;

  wire PCCond,WriteData,PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zwe,nwe,cwe,iset,ireset,eset,ereset,Enq,Deq,PCWriteCond;
	wire [1:0]AluA,AluB,PCSrc,RReg,RegDst,RegData,AluOp;


	DataPath	DP(IsFull,IsEmpty,i,Op,PCCond,WriteData,PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zwe,nwe,cwe,iset,ireset,eset,ereset,PCWriteCond,AluA,AluB,PCSrc,RReg,RegDst,RegData,AluOp,reset,Enq,Deq,clk);
  Control CTRL(IsFull,IsEmpty,i,Op,PCCond,WriteData,PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zwe,nwe,cwe,iset,ireset,eset,ereset,PCWriteCond,AluA,AluB,PCSrc,RReg,RegDst,RegData,AluOp,reset,Enq,Deq,clk);

initial
begin
	reset=1;
	#1;
	clk=1;
	DP.InstReg.Data = 16'h4000;	
	#8;
	reset=0;
	#5000;
	$stop;
end

always #5 clk=~clk;

endmodule