//Memmory unit
//Kamyar Rafati & Naeem Esfahani

module QueueMemory(address,ind,outd,we,re,clk);
	input[15:0]		ind;
	input[5:0]		address;
	input			re, we,clk;
	output[15:0]	outd;
	reg[15:0]		memory[63:0];
	reg[15:0]		outd;
	wire			re_clk;


	assign re_clk = re & clk;

// loads a hex code from file mem.dat to the memory, the format for the file 
//is as follows: you specify a 3-bit hex address at each line then 8 bit instruction 
//is followed(start at address 000)

	always @ (posedge re_clk or address)
	begin
		if (re) outd = memory[address];
	end

	always @(posedge clk)
	begin
		if (we == 1) memory[address] = ind;
	end
endmodule



