//1 bit Register
//Kamyar Rafati & Naeem Esfahani

module Reg_16bit_a (MData, Y, enable, reset, CLK);
	input	[15:0] MData;
	input	CLK, reset, enable;
	output	[15:0] Y;
	reg		[15:0] Data;

	assign Y = Data;
	always @(MData or enable)
	begin
		if (!reset && enable) Data = MData;
	end

	always @(posedge reset)
	begin
		Data = 0;
	end
endmodule
