//16 bit to 32 bit sign extender
//Kamyar Rafati & Naeem Esfahani

module SignExtend_16bit (a, y);
	input[7:0]		a;
	output[15:0]	y;
	reg[15:0]		y;

	always @(a)
	begin
		if (a[7] == 1)
			y[15:8] = 8'b11111111;
		else
			y[15:8] = 8'b00000000;
			
		y[7:0] = a;
	end
endmodule
